class CfgPatches
{
	class jac_zeus_wargame
	{
		// Meta information for editor
		name = "ZEUS WARGAME MOD";
		author = "JACKTHEVIPER";
		url = "https://www.patreon.com/jacktheviper";

		// Minimum compatible version. When the game's version is lower, pop-up warning will appear when launching the game. Note: was disabled on purpose some time late into Arma 2: OA.
		requiredVersion = 1.0;
		// Required addons, used for setting load order.
		// When any of the addons is missing, pop-up warning will appear when launching the game.
		requiredAddons[] = {"CBA_main"};	//
		// List of objects (CfgVehicles classes) contained in the addon. Important also for Zeus content (units and groups) unlocking.
		units[] = {};
		// List of weapons (CfgWeapons classes) contained in the addon.
		weapons[] = {};
	};
};


//// init
class Extended_preInit_EventHandlers 
{
	class jac_zeusWargameMissionPreInitClass
	{
		init = "[] execVM '\jac_arma_wargame\data\scripts\jac_wargameMain.sqf';";
	};
};



///// AI suppression change
//AI is more susceptible to suppression from bullets and explosions
class CfgBrains {
    class DefaultSoldierBrain {
        class Components {
			class AIBrainCountermeasuresComponent {
				useSmokeGrenadeDelay = 600;
				CMCheckDelay = 0.8;
				suppressionThreshold = 0.9;
				nonLeaderSmokeProbability = 0.01;
				CMOnTargettedProbability =0.1;
				suppressionTimerMax = 3;
				minimalThrowDistance = 900;
				minReactionTime = 0.5;
				maxReactionTime = 3;
				randomReactionTimePercent = 0.1;
			};
			
            class AIBrainSuppressionComponent {
				maxSuppression = 1;	//1
                worstDecreaseTime = 10.0;   // in seconds for 0.0 skill
                bestDecreaseTime = 6.0;     // in seconds for 1.0 skill
                causeExplosionWeight = 6; //
				SuppressionThreshold = 1; //0.7
            };
			
            class AIBrainAimingErrorComponent {
                worstDecreaseTime = 3; // how long (in seconds) it should take 0.0 skilled soldier to stabilize the aim completely
                bestDecreaseTime = 1; // how long (in seconds) it should take 1.0 skilled soldier to stabilize the aim completely
                turningInfluence = 1; // importance of turning in algorithm, multiplier	- 1.1
				suppressionCoef = 0.5;// importance of suppression value, multiplier - 0.5
            };
        };
    };
};


////// mod insignia
class CfgUnitInsignia
{
	class jac_insigniaViper
	{
		displayName = "the viper";								// Name displayed in Arsenal
		author = "jacktheviper";											// Author displayed in Arsenal
		texture = "\jac_arma_wargame\data\images\jac_theViperLogo.paa";			// Image path
		material = "\A3\Ui_f\data\GUI\Cfg\UnitInsignia\default_insignia.rvmat";	// .rvmat path
		textureVehicle = "";													// Does nothing, reserved for future use
	};
	
	class jac_insigniaModLogo
	{
		displayName = "Fire and Maneuver";								// Name displayed in Arsenal
		author = "jacktheviper";											// Author displayed in Arsenal
		texture = "\jac_arma_wargame\data\images\mainLogoWhite.paa";			// Image path
		material = "\A3\Ui_f\data\GUI\Cfg\UnitInsignia\default_insignia.rvmat";	// .rvmat path
		textureVehicle = "";													// Does nothing, reserved for future use
	};
	
	class jac_insigniaModLogoYellow
	{
		displayName = "Fire and Maneuver [yellow]";								// Name displayed in Arsenal
		author = "jacktheviper";											// Author displayed in Arsenal
		texture = "\jac_arma_wargame\data\images\mainLogo.paa";			// Image path
		material = "\A3\Ui_f\data\GUI\Cfg\UnitInsignia\default_insignia.rvmat";	// .rvmat path
		textureVehicle = "";													// Does nothing, reserved for future use
	};
};


////// WARGAME MODULES
//modules for setting up missions

//create category
class CfgFactionClasses
{
	class WRG_CATEGORY;
	class jac_wargameModules: WRG_CATEGORY
	{
		displayName = "Wargame Modules";
	};
};

/////// MODULES config
class CfgVehicles
{
	class Logic;
	class Module_F: Logic
	{
		class AttributesBase
		{
			class Default;
			class Edit;					// Default edit box (i.e., text input field)
			class Combo;				// Default combo box (i.e., drop-down menu)
			class Checkbox;				// Default checkbox (returned value is Boolean)
			class CheckboxNumber;		// Default checkbox (returned value is Number)
			class ModuleDescription;	// Module description
			class Units;				// Selection of units on which the module is applied
		};
		// Description base classes, for more information see below
		class ModuleDescription
		{
			class AnyBrain;
		};
	};
	
	
	/////////////// ZEUS INIT MODULE
	//zeus init module, turns synched player characters into Zeus and adds synched units to its control
	class jac_moduleInitWargameZeus: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "-Wargame Zeus Init"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_moduleInitWargameZeus.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleInitWargameZeus";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 2;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 2;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Arguments shared by specific module type (have to be mentioned in order to be present)
			// Module specific arguments
			class jac_isForcedWargameZeusInterface: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_isForcedWargameZeusInterface_property";
				displayName = "Forced Interface"; // Argument label
				tooltip = "Defines if the Zeus player should be able to leave the Zeus interface."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_canEditUnitsZeus: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canEditUnitsZeus_property";
				displayName = "Unit Editing"; // Argument label
				tooltip = "If the Zeus should be allowed to freely move and edit units in the Zeus interface, it's off by default to prevent cheating in Wargame scenarios."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class jac_canPlaceUnitsZeus: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canPlaceUnitsZeus_property";
				displayName = "Unit creation"; // Argument label
				tooltip = "Allow the player to place units using the create menu, press SHIFT+H to enable the create menu in case you can't see it."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class jac_canPlaceUnitsZeusResource: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canPlaceUnitsZeusResource_property";
				displayName = "Unit Creation Resource"; // Argument label
				tooltip = "Set how many points the Zeus will have to create units, max value is 1000. \nSet unit cost with the Unit Cost Module. \nCan get more points from capturing objetive areas."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "1000"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class jac_canPlaceUnitsZeusPopulationcap: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canPlaceUnitsZeusPopulationcap_property";
				displayName = "Unit Population Capacity"; // Argument label
				tooltip = "Use this number to set a maximum amount of units and objects that can be placed by the Zeus at the same time. \nWorks together with the Unit Population Cost parameter from the Unit Cost Module. \nSet a value up to 1000, leave at 0 to disable."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class jac_canRemoteControlUnits: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canRemoteControlUnits_property";
				displayName = "Block Direct Control"; // Argument label
				tooltip = "Defines if the Zeus player should be able to direct control AI units, overrides the Addon Options settings, will hide the 'direct control' option in the T menu."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//force ammo use
			class jac_forceAmmoUse: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_forceAmmoUse_property";
				displayName = "Force ammo use on suppression"; // Argument label
				tooltip = "Check this option to force both infantry and vehicles to expend ammo while suppressing, overrides the Addon Options settings."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//prevent using the wargame cheat mode
			class jac_blockWargameCheats: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canUseWargameCheats_property";
				displayName = "Block Wargame cheats"; // Argument label
				tooltip = "Check this option to prevent the player from using the garrison action to teleport units, the engineer fortifications cheat mode and the 'Zeus anywhere mode', overrides all Addon Options settings."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//if the ability to add friendly units and empty vehicles with the tactical menu option is available
			class jac_canAddObjectsVariable: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canAddObjects_property";
				displayName = "Show Add Objects"; // Argument label
				tooltip = "Uncheck this option to prevent the player from having the ability to recruit friendly units and empty vehicles with the 'Add objects' tactical menu option, will hide the 'Add objects' option in the T menu."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//night vision
			class jac_zeusEnableNV: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_zeusEnableNV_property";
				displayName = "Allow Nightvision"; // Argument label
				tooltip = "Uncheck this option to remove the nightvision mode from the Zeus camera."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//thermal vision
			class jac_zeusEnableThermal: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_zeusEnableThermal_property";
				displayName = "Allow Thermal Vision"; // Argument label
				tooltip = "Uncheck this option to remove the thermal mode from the Zeus camera."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//show score bar
			class jac_zeusEnableScorebar: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_zeusEnableScorebar_property";
				displayName = "Show the scorebar"; // Argument label
				tooltip = "Uncheck this option to hide the scorebar that shows how many Victory Points each side has."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_cameraAreaActive: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_cameraAreaActive_property";
				displayName = "Add camera area restriction"; // Argument label
				tooltip = "Check this option to set the area the camera will be restricted to, customize the area parameters in the following atributes."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_cameraFollowingObjectName: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_cameraFollowingObjectName_property";
				displayName = "Object the camera will follow"; // Argument label
				tooltip = "Enter the Variable Name of the object or unit the camera area should center around."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = ""; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class jac_cameraAreaSize: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_cameraAreaSize_property";
				displayName = "Size of the camera area."; // Argument label
				tooltip = "Enter a number to set the camera area."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "1000"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_cameraAreaCeiling: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_cameraAreaCeiling_property";
				displayName = "Max height of the camera area."; // Argument label
				tooltip = "Enter a number to set the max height the camera will be able to move within the camera area."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "250"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};

			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch the player character and the units he should be able control to this module."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Players will gain access to Zeus wargame mode.",
					"Units and vehicles will be placed under control of the Zeus."
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"Anything"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//SET UNIT CREATION COST MODULE
	class jac_moduleUnitCostWargameZeus: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Unit Cost Module"; // Name displayed in the menu
		icon = "\a3\ui_f\data\igui\cfg\simpletasks\types\Use_ca.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleUnitCostWargameZeus";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 2;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Arguments shared by specific module type (have to be mentioned in order to be present)
			// Module specific arguments
			
			/// Unit Creation Cost
			class jac_canPlaceUnitsZeusCost: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canPlaceUnitsZeusCost_property";
				displayName = "Unit Creation Cost"; // Argument label
				tooltip = "Sets how many Zeus points this unit will cost to be created, set a value from 0 to 1000"; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// Unit Population Cost
			class jac_canPlaceUnitsZeusPopulationCost: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_canPlaceUnitsZeusPopulationCost_property";
				displayName = "Unit Population Cost"; // Argument label
				tooltip = "Sets how much Population Capacity this unit will cost, works together with the Unit Population Capacity parameter from the Wargame Zeus Init Module, set a value from 0 to 1000"; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "5"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// Unit Zeus Reward
			class jac_unitCostModuleZeusReward: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_unitCostModuleZeusReward_property";
				displayName = "Zeus Points Reward"; // Argument label
				tooltip = "When a unit of the kind synched to this module is killed, Zeus players that control the killer will receive this amount of Zeus creation points as a reward, the value can be set from 0 to 1000"; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// Victory Points Reward
			class jac_unitCostModuleVPReward: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_unitCostModuleVPReward_property";
				displayName = "Victory Points Reward"; // Argument label
				tooltip = "When a unit of the kind synched to this module is killed, the side which the killer belongs to will receive this amount of Victory Points as a reward, the value can be set from 0 to 100"; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// add crew
			class jac_unitCostModuleAddCrew: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_unitCostModuleAddCrew_property";
				displayName = "Add Vehicle Crew"; // Argument label
				tooltip = "Check this option to automatically add a crew to vehicles, otherwise the vehicles will be empty when placed by the player"; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// save loadout
			class jac_unitCostModuleSaveLoadout: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_unitCostModuleSaveLoadout_property";
				displayName = "Save Current Loadout"; // Argument label
				tooltip = "When checked the current unit or vehicle loadout and appearance will be used when placed by the player, uncheck in case you want to use a unit with randomized loadout."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// start aircraft in the air
			class jac_unitCostModuleStartInAir: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_unitCostModuleStartInAir_property";
				displayName = "Start in the air"; // Argument label
				tooltip = "If this option is checked, aircraft placed by the Zeus will start at flying altitude."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// synced wargame Zeus modules
			class jac_unitCostModuleSyncedZeusOwner: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_unitCostModuleSyncedZeusOwner_property";
				displayName = "Synced wargame Zeus modules"; // Argument label
				tooltip = "The units synced to this module will only appear in the creation list of the Zeus players synced to 'Wargame Zeus Init' modules that are also synced to this module instead of being added to the whole faction."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// set side owner - drop down menu
			class jac_setModuleOwner: combo
			{
				property = "jac_setModuleOwner_property";				// Unique property (use "<tag>_<moduleClass>_<attributeClass>" format to ensure that the name is unique)
				displayName = "Side Owner";			// Argument label
				tooltip = "Side that will be allowed to place the synched units.";	// Tooltip description
				typeName = "NUMBER";							// Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0";							// Default attribute value. Warning: this is an expression, and its returned value will be used (50 in this case).

				// Listbox items
				class Values
				{
					class areaOwnerBluefor	{ name = "BLUFOR";	value = 0; };
					class areaOwnerOpfor	{ name = "OPFOR";	value = 1; };
					class areaOwnerIndfor	{ name = "independent";	value = 2; };
				};
			};
			
			//init custom code
			class jac_costModuleUnitInitCode: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_costModuleUnitInitCode_property";
				control = "EditCodeMulti5";
				displayName = "Custom init code"; // Argument label
				tooltip = "Code that will be executed when units of the same class as the one synched to this module are placed by the Zeus, use _this to reference the unit."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "''"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch this module to the units or vehicles that you want to set the creation cost in zeus mode"; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to the units or vehicles that you want to set the creation cost in zeus mode.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 0; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"Anything"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	
	////////////// WARGAME RULES MODULE
	//set parameters for the PVP wargame mode
	class jac_moduleWargameRules: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "PVP Mode Init"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_moduleWargameRules.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleWargameRules";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 2;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Arguments shared by specific module type (have to be mentioned in order to be present)
						
			//Victory points
			class jac_victoryPointsToWin: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_victoryPointsToWin_property";
				displayName = "Victory Points to win"; // Argument label
				tooltip = "Defines the amount of Victory Points a player needs to win the match."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "100"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//prep time
			class jac_preparationPhaseTimer: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_preparationPhaseTimer_property";
				displayName = "Preparation phase time"; // Argument label
				tooltip = "How long the preparation time at the beginning of the match will last, in seconds."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "30"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//max game time
			class jac_matchGameTime: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_matchGameTime_property";
				displayName = "Max game time"; // Argument label
				tooltip = "How long the match will last, when the time ends, the side with the most Victory Points wins, in seconds."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "1800"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//game ends if all killed?
			class jac_endGameWhenSideIsDead: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_endGameWhenSideIsDead_property";
				displayName = "Destruction victory condition"; // Argument label
				tooltip = "If the game should automatically end when only one side still has units left alive."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_customVictoryCode: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_customVictoryCode_property";
				displayName = "Custom victory condition"; // Argument label
				tooltip = "If the game should automatically end when only one side still has units left alive."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "'false'"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "place 1 of these to set the rules for the Wargame PVP match."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Set parameters for the Wargame PVP match.",
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {""}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	
	//////////////// ZEUS WARGAME SET OBJECTIVE AREA MODULE
	//set the size of the objective area for the PVP mode - set default owner and timer
	class jac_moduleObjArea: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Respawn Base/Objective Area"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_moduleObjArea.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleObjArea";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 1;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";
		
		// 3DEN Attributes Menu Options
		canSetArea = 1;						// Allows for setting the area values in the Attributes menu in 3DEN
		canSetAreaShape = 0;				// Allows for setting "Rectangle" or "Ellipse" in Attributes menu in 3DEN
		canSetAreaHeight = 1;				// Allows for setting height or Z value in Attributes menu in 3DEN
		class AttributeValues
		{
			// This section allows you to set the default values for the attributes menu in 3DEN
			size3[] = { 50, 50, 5 };		// 3D size (x-axis radius, y-axis radius, z-axis radius)
			isRectangle = 1;				// Sets if the default shape should be a rectangle or ellipse
		};

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			
			//objective name
			class jac_objectiveAreaName: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaName_property";
				displayName = "Name"; // Argument label
				tooltip = "Name used to identify this objective."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "'Point Alpha'"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			//default owner - drop down menu
			class jac_setObjectiveAreaOwner: combo
			{
				property = "jac_setObjectiveAreaOwner_property";				// Unique property (use "<tag>_<moduleClass>_<attributeClass>" format to ensure that the name is unique)
				displayName = "Default owner";			// Argument label
				tooltip = "Change this if you want this objective to start already captured by a side.";	// Tooltip description
				typeName = "NUMBER";							// Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "3";							// Default attribute value. Warning: this is an expression, and its returned value will be used (50 in this case).

				// Listbox items
				class Values
				{					
					class areaOwnerBluefor	{ name = "BLUFOR";	value = 0; };
					class areaOwnerOpfor	{ name = "OPFOR";	value = 1; };
					class areaOwnerIndfor	{ name = "independent";	value = 2; };
					class areaOwnerNeutral	{ name = "NEUTRAL";	value = 3; };
				};
			};
			
			//time to capture objective
			class jac_objectiveAreaCaptureTime: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaCaptureTime_property";
				displayName = "Time to capture"; // Argument label
				tooltip = "Set the time to capture this objective area."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "60"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//victory points awarded
			class jac_objectiveAreaRewardPoints: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaRewardPoints_property";
				displayName = "Victory Points Reward"; // Argument label
				tooltip = "how many Victory Points the side will gain from capturing this objective."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "100"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//zeus points awarded
			class jac_objectiveAreaZeusPoints: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaZeusPoints_property";
				displayName = "Zeus Points Reward"; // Argument label
				tooltip = "how many Zeus unit creation points the side will gain from capturing this objective, max value is 1000."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "100"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			//victory points are continuously awarded
			class jac_objectiveAreaRewardPointsContinuous: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaRewardPointsContinuous_property";
				displayName = "Award Victory Points Continuously"; // Argument label
				tooltip = "award Victory and Zeus Points continuously everytime this amount of second has passed, set to 0 to only give the reward once."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "30"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};						
			
			//if the point will be considered the main respawn base for the side
			class jac_objectiveAreaRespawnPoint: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaRespawnPoint_property";
				displayName = "Respawn Base"; // Argument label
				tooltip = "check this option to make this objective the Respawn Base for the side owner, each side can only have 1 respawn base."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//if the point will add a deployment zone to the side that captures it
			class jac_objectiveAreaDeploymentZone: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaDeploymentZone_property";
				displayName = "Deployment Area"; // Argument label
				tooltip = "check this option to make this objective add a unit Deployment Area to the side that captures it."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//if the point can be used as a redeploy (teleport) point
			class jac_objectiveAreaRedeployPoint: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaRedeployPoint_property";
				displayName = "Redeploy Point"; // Argument label
				tooltip = "check this to add the REDEPLOY option to this Point, which will teleport currently selected units to this position."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//if the point can be used as a redeploy (teleport) point
			class jac_objectiveAreaRedeployPointParadrop: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaRedeployPointParadrop_property";
				displayName = "Redeploy paradrop"; // Argument label
				tooltip = "If unchecked, redeployed units will be placed direct on the ground instead of being paradropped."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//if the point can be used as a supply point
			class jac_objectiveAreaSupplyPoint: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaSupplyPoint_property";
				displayName = "Supply Point"; // Argument label
				tooltip = "Set to a value higher than 0 to add the SUPPLY option to this point, which can be used to restore infantry groups and vehicles to their original state."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			//time in seconds to respawn
			class jac_objectiveAreaRespawnTimeInfantry: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaRespawnTimeInfantry_property";
				displayName = "Infantry Respawn Time"; // Argument label
				tooltip = "If this objective point is set to be the Respawn Base, infantry groups will have wait this amount of seconds before respawning"; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "jac_strongpoint_respawnDefault"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			//time in seconds to respawn
			class jac_objectiveAreaRespawnTimeVehicle: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaRespawnTimeVehicle_property";
				displayName = "Vehicle Respawn Time"; // Argument label
				tooltip = "If this objective point is set to be the Respawn Base, vehicles will have to wait this amount of seconds before respawning"; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "jac_respawnDefaultVehicle"; // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			//objective captured custom code
			class jac_objectiveAreaCode: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_objectiveAreaCode_property";
				control = "EditCodeMulti5";
				displayName = "Exec when objective is taken"; // Argument label
				tooltip = "Code executed when this objective is captured, parameters passed: (_this # 0) point position in format ASL; (_this # 1) the side that just captured it; (_this # 2) the side that previously owned it; (_this # 3) list of units inside the area; (_this # 4) list of Zeus (curator logic) that have controllable units inside the area; (_this # 5) this logic object."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"				
				defaultValue = "''" // Default attribute value. WARNING: This is an expression, and its returned value will be used
				//params ['_centerPosition','_currentSideOwner', '_lastSideOwner', '_unitsInsideArea', '_zeusList', '_logic'];
			};
			
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Set the bases/objective areas for Wargame scenarios, can be resized."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Set the objective area",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"Anything"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	

	//////////////// ZEUS WARGAME SET PREPARATION AREA MODULE
	//set the size of the preparation phase area for the PVP mode
	class jac_modulePrepArea: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Deployment Area"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_modulePrepPhaseArea.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_modulePrepArea";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 2;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 1;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";
		
		// 3DEN Attributes Menu Options
		canSetArea = 1;						// Allows for setting the area values in the Attributes menu in 3DEN
		canSetAreaShape = 0;				// Allows for setting "Rectangle" or "Ellipse" in Attributes menu in 3DEN
		canSetAreaHeight = 0;				// Allows for setting height or Z value in Attributes menu in 3DEN
		class AttributeValues
		{
			// This section allows you to set the default values for the attributes menu in 3DEN
			size3[] = { 250, 250, -1 };		// 3D size (x-axis radius, y-axis radius, z-axis radius)
			isRectangle = 0;				// Sets if the default shape should be a rectangle or ellipse
		};

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			
			/// set side owner - drop down menu
			class jac_setPreparationAreaOwner: combo
			{
				property = "jac_setPreparationAreaOwner_property";				// Unique property (use "<tag>_<moduleClass>_<attributeClass>" format to ensure that the name is unique)
				displayName = "Deployment area";			// Argument label
				tooltip = "Side that will be allowed to use this deployment area.";	// Tooltip description
				typeName = "NUMBER";							// Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0";							// Default attribute value. Warning: this is an expression, and its returned value will be used (50 in this case).

				// Listbox items
				class Values
				{
					class areaOwnerBluefor	{ name = "BLUFOR";	value = 0; };
					class areaOwnerOpfor	{ name = "OPFOR";	value = 1; };
					class areaOwnerIndfor	{ name = "independent";	value = 2; };
				};
			};
			
			/// if this deployment area should disappear after the prep phase
			class jac_setPreparationAreaRemove: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_setPreparationAreaRemove_property";
				displayName = "Remove after Preparation Phase"; // Argument label
				tooltip = "If checked, this Deployment Area will disappear automatically when the Combat Phase starts after the preparation phase."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Set the deployment area for a Wargame match, can be resized, if placing units is allowed, can place units inside this area."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Set the preparation phase area",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	///////// GROUP TRAIT INIT MODULES
	
	//HQ trait
	class jac_moduleInitTraitHQ: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Group Trait - HQ"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_HQgroup.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleInitTraitHQ";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch to any unit to give its group the HQ trait."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to any unit to give its group the HQ trait.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//FO trait
	class jac_moduleInitTraitFOClass: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Group Trait - Forward Observer"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_FOicon.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleInitTraitFO";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{			
			class jac_moduleInitTraitFO: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleInitTraitFO_property";
				displayName = "Forward Observer max range"; // Argument label
				tooltip = "Set the max range the Forward Observer can spot targets for indirect fire."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "jac_isFOdefaultRange"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch to any unit to give its group the Forward Observer trait."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to any unit to give its group the Forward Observer trait.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//supply point trait
	class jac_moduleInitTraitSupplyClass: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Object Trait - Supply Point"; // Name displayed in the menu
		icon = "\a3\ui_f\data\igui\cfg\simpletasks\types\Container_ca.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleInitTraitSupply";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			//Supply Points amount
			class jac_moduleInitTraitSupply: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleInitTraitSupply_property";
				displayName = "Supply Points amount"; // Argument label
				tooltip = "Set the amount of Supply Points the synched object or unit will start with."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "1000"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//Supply Points limit
			class jac_moduleInitTraitSupplyLimit: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleInitTraitSupplyLimit_property";
				displayName = "Supply Points Capacity"; // Argument label
				tooltip = "Set the maximum amount of Supply Points the synched object or unit can hold."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "1000"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//Supply Points resupply
			class jac_moduleInitTraitSupplyReplenish: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleInitTraitSupplyReplenish_property";
				displayName = "Replenish Supply Points"; // Argument label
				tooltip = "Every 30 seconds will generate this amount of Supply Points, leave at 0 to disable."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//Supply Points resupply
			class jac_isSupplyPointReinforceGroup: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_isSupplyPointReinforceGroup_property";
				displayName = "Reinforce Infantry groups"; // Argument label
				tooltip = "Check this option to determine if the supply point can be used to reinforce infantry groups, respawning dead units."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch to a vehicle, soldier or object to turn it into a supply point."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch to a vehicle or object to turn it into a supply point.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//engineer trait
	class jac_moduleInitTraitEngineerClass: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Group Trait - Combat Engineer"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_spadeIcon.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleInitTraitEngineer";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			//time to capture objective
			class jac_moduleInitTraitEngineer: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleInitTraitEngineer_property";
				displayName = "Fortification Points"; // Argument label
				tooltip = "Set the amount of Fortification Points the synched units will have."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "100"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch to any unit to give its group the Combat Engineer trait."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to any unit to give its group the Combat Engineer trait.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//EOD trait
	class jac_moduleInitTraitEOD: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Group Trait - EOD"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_deminingIcon.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleInitTraitEOD";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch to any unit to give its group the the ability to clear explosives and mines."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to any unit to give its group the the ability to clear explosives and mines.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//set radio range
	class jac_moduleInitTraitRadioClass: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Group Trait - Radio range"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_radioIcon.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleInitTraitRadio";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{			
			class jac_moduleInitTraitRadio: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleInitTraitRadio_property";
				displayName = "Radio Range"; // Argument label
				tooltip = "Set the max radio communication range of the synched unit's groups, used for sharing targets with nearby groups and calling indirect fire support."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "jac_GrpDefaultRadioRange"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch this module to any unit to set its radio communication range."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to any unit to set its radio communication range.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//// FOG OF WAR parameters module
	class jac_moduleFogOfWarParametersClass: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Fog Of War parameters"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_eyeIcon.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleFogOfWarParameters";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 1;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// set fog of war view range
			class jac_moduleFogOfWarParametersViewRange: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleFogOfWarParametersViewRange_property";
				displayName = "View Range"; // Argument label
				tooltip = "Set the base view range in meters for units synched to this module, the max view range is 4000, when synched to a vehicle, the value will be used for units that enter the vehicle."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "1200"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// set stealth bonus to the unit
			class jac_moduleFogOfWarParametersStealthBonus: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleFogOfWarParametersStealthBonus_property";
				displayName = "Base Stealth Bonus"; // Argument label
				tooltip = "You can use this setting to make an unit stealthier, set a value between 0 and 100, the enemy View Range will be reduced by that value as a percentage."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// blacklist from fog of war system
			class jac_moduleFogOfWarParametersBlacklist: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleFogOfWarParametersBlacklist_property";
				displayName = "Blacklist from Fog Of War"; // Argument label
				tooltip = "Check this option to blacklist the synched unit from the fog of war system, this means that they won't be hidden or unhidden automatically."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// affect only synched units or entire class
			class jac_moduleFogOfWarParametersTargets: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleFogOfWarParametersTargets_property";
				displayName = "Affect synched units only"; // Argument label
				tooltip = "Leave this option checked to only affect the units synched to this module, otherwise it will affect all units of the same class."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "true"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch to any unit to edit its fog of war parameters; vision range, base stealth bonus."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch to any unit to edit its fog of war parameters.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//// PATROL/QRF GROUPS MODULE
	class jac_moduleDynamicPatrol: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Dynamic Patrol"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_circle.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleDynamicPatrol";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 1;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synched units will act as a Dynamic Patrol, will move to the position of a friendly group within radio comms range that comes under attack."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synched units will act as a Dynamic Patrol, will move to the position of a friendly group within radio comms range that comes under attack.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	
	//// PATH PLANNING MODULE
	//used to visualize the path planning
	class jac_modulePathPlanningLogic: Module_F
	{
		// Standard object definitions
		scope = 1; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Path Planning Logic"; // Name displayed in the menu
		icon = "\a3\ui_f\data\igui\cfg\simpletasks\types\interact_ca.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "PATH PLANNING MODULE"; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"PATH PLANNING MODULE",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	
	//// CUSTOM FORTICATIONS ARRAY
	class jac_moduleCustomFortifications: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Custom Fortifications"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\jac_shieldIcon.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleCustomFortifications";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{			
			class jac_moduleCustomFortificationsName: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomFortificationsName_property";
				displayName = "Fortification Name"; // Argument label
				tooltip = "Name of the option that will appear on the engineer fortifications menu."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "'custom fortification'"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomFortificationsSpacing: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomFortificationsSpacing_property";
				displayName = "Spacing"; // Argument label
				tooltip = "The interval in meters between each fortification object when placed in a line."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "5"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomFortificationsDuration: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomFortificationsDuration_property";
				displayName = "Duration"; // Argument label
				tooltip = "The time necessary to build the fortification object."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "30"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomFortificationsCost: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomFortificationsCost_property";
				displayName = "Cost"; // Argument label
				tooltip = "How many Fortification Points the engineer group must have to place this fortification object."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "25"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomFortificationsDirectionFix: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomFortificationsDirectionFix_property";
				displayName = "Placement Direction"; // Argument label
				tooltip = "The direction that the object will be facing when placed, use 180 if the object is being placed backwards, 90 if its being placed sideways."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomFortificationsDeleteOriginal: checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomFortificationsDeleteOriginal_property";
				displayName = "Remove Default Fortifications"; // Argument label
				tooltip = "Check this box to remove all the default fortification menu options that are available by default."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch this module to an object to make it available on the engineer fortifications menu."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to an object to make it available on the engineer fortifications menu.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	
	/////// CUSTOM SENSITIVE MENU OPTION
	class jac_moduleCustomMenu: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Custom Menu"; // Name displayed in the menu
		icon = "\a3\ui_f\data\igui\cfg\simpletasks\types\interact_ca.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_moduleCustomMenu";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{			
			class jac_moduleCustomMenuName: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomMenuName_property";
				displayName = "Menu Name"; // Argument label
				tooltip = "The name that will appear on the option."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "'MENU OPTION'"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomMenuTooltip: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomMenuTooltip_property";
				displayName = "Tooltip"; // Argument label
				tooltip = "Message that will appear above the menu when the mouse point is hovering above it."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "'Click on this option to activate it.'"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomMenuRequireSelected: checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomMenuRequireSelected_property";
				displayName = "Require Selected"; // Argument label
				tooltip = "If checked, the menu option will only appear if the player has a unit currently selected."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			class jac_moduleCustomMenuCode: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_moduleCustomMenuCode_property";
				control = "EditCodeMulti5";
				displayName = "Exec Code"; // Argument label
				tooltip = "Code that will be executed when the option is clicked on."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = ""; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synch this module to an object to add a custom context sensitive menu to it."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synch this module to an object to add a custom context sensitive menu to it.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//// WARGAME GENERIC LOGIC
	//used when creating a logic object is necessary to improve visualization
	class jac_wargameLogic: Module_F
	{
		// Standard object definitions
		scope = 1; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Wargame Logic"; // Name displayed in the menu
		icon = "\jac_arma_wargame\data\images\mainLogoWhite.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 0;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "WARGAME GENERIC LOGIC"; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"WARGAME GENERIC LOGIC",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	///// ZEUS TACTICAL PING
	class jac_wargameTacticalPing: Module_F
	{
		// Standard object definitions
		scope = 1; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Tactical Ping"; // Name displayed in the menu
		icon = "\A3\ui_f\data\map\markers\military\warning_CA.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 1;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 0;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "WARGAME TACTICAL PING"; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"WARGAME TACTICAL PING",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
	
	//////////////// AIRCRAFT CONTROL MODULES
	class jac_virtualAirSupport: Module_F
	{
		// Standard object definitions
		scope = 2; // Editor visibility; 2 will show it in the menu, 1 will hide it.
		displayName = "Air Support module"; // Name displayed in the menu
		icon = "\a3\ui_f\data\igui\cfg\simpletasks\types\Plane_ca.paa"; // Map icon. Delete this entry to use the default icon
		category = "jac_wargameModules";

		// Name of function triggered once conditions are met
		function = "jac_fnc_virtualAirSupport";
		// Execution priority, modules with lower number are executed first. 0 is used when the attribute is undefined
		functionPriority = 1;
		// 0 for server only execution, 1 for global execution, 2 for persistent global execution
		isGlobal = 2;
		// 1 for module waiting until all synced triggers are activated
		isTriggerActivated = 1;
		// 1 if modules is to be disabled once it is activated (i.e., repeated trigger activation won't work)
		isDisposable = 0;
		// 1 to run init function in Eden Editor as well
		is3DEN = 0;

		// Menu displayed when the module is placed or double-clicked on by Zeus
		curatorInfoType = "";
		
		// 3DEN Attributes Menu Options
		canSetArea = 0;						// Allows for setting the area values in the Attributes menu in 3DEN
		canSetAreaShape = 0;				// Allows for setting "Rectangle" or "Ellipse" in Attributes menu in 3DEN
		canSetAreaHeight = 0;				// Allows for setting height or Z value in Attributes menu in 3DEN
		class AttributeValues
		{
			// This section allows you to set the default values for the attributes menu in 3DEN
			size3[] = { 250, 250, -1 };		// 3D size (x-axis radius, y-axis radius, z-axis radius)
			isRectangle = 0;				// Sets if the default shape should be a rectangle or ellipse
		};

		// Module attributes, uses https://community.bistudio.com/wiki/Eden_Editor:_Configuring_Attributes#Entity_Specific
		class Attributes: AttributesBase
		{
			// Module specific arguments
			
			//option Custom Name
			class jac_virtualAirSupportName: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportName_property";
				displayName = "Custom Name"; // Argument label
				tooltip = "Set a custom name for this aircraft, otherwise it will use the default name that appears in the Editor."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"				
				defaultValue = "''" // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			/// cost in zeus points
			class jac_virtualAirSupportCost: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportCost_property";
				displayName = "Cost"; // Argument label
				tooltip = "Set the amount of Zeus creation points that will be used to call air support, set a number from 0 to 1000."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			/// number of uses
			class jac_virtualAirSupportAvailability: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportAvailability_property";
				displayName = "number of uses"; // Argument label
				tooltip = "Set the amount of times the player will be able to call for air support from aircraft synced to this module, leave at 0 for unlimited uses."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "0"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			/// start in cooldown
			class jac_virtualAirSupportStartInCooldown: Checkbox
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportStartInCooldown_property";
				displayName = "Start in cooldown"; // Argument label
				tooltip = "If aircraft synced to this module will start in cooldown or will be immediately available."; // Tooltip description
				typeName = "BOOL"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "false"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			/// cooldown after use
			class jac_virtualAirSupportCooldown: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportCooldown_property";
				displayName = "Cooldown"; // Argument label
				tooltip = "Set the time in seconds the player has to wait to call for air support from aircraft synced to this module again."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "60"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			/// cooldown after use if the aircraft is downed
			class jac_virtualAirSupportCooldownDestroyed: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportCooldownDestroyed_property";
				displayName = "Cooldown if destroyed"; // Argument label
				tooltip = "Set the time in seconds the player has to wait to call for air support again if the aircraft is destroyed by enemy fire."; // Tooltip description
				typeName = "NUMBER"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "120"; // Default attribute value. WARNING: This is an expression, and its returned value will be used 
			};
			
			//support condtion
			class jac_virtualAirSupportCondition: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportCondition_property";
				displayName = "Condition"; // Argument label
				tooltip = "This condition must return true for the aircraft to become available for use in the Air Control menu."; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"				
				defaultValue = "'true'" // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			//aircraft creation custom code
			class jac_virtualAirSupportExecCode: Edit
			{
				// Unique property, use "<moduleClass>_<attributeClass>" format to make sure the name is unique in the world
				property = "jac_virtualAirSupportExecCode_property";
				control = "EditCodeMulti5";
				displayName = "Aircraft custom code"; // Argument label
				tooltip = "Code executed when the called aircraft is created, parameters passed: (_this # 0) the aircraft; (_this # 1) the target position;"; // Tooltip description
				typeName = "STRING"; // Value type, can be "NUMBER", "STRING" or "BOOL"
				defaultValue = "''" // Default attribute value. WARNING: This is an expression, and its returned value will be used
			};
			
			class ModuleDescription: ModuleDescription{}; // Module description should be shown last
		};

		// Module description. Must inherit from base class, otherwise pre-defined entities won't be available
		class ModuleDescription: ModuleDescription
		{
			description = "Synchonize to the Zeus Player unit that will be able to call air support from the aircraft synced to this module."; // Short description, will be formatted as structured text
			sync[] = {"LocationArea_F"}; // Array of synced entities (can contain base classes)

			class LocationArea_F
			{
				description[] = { // Multi-line descriptions are supported
					"Synchonize to the Zeus Player unit that will be able to call air support from the aircraft synced to this module.",
					""
				};
				position = 0; // Position is taken into effect
				direction = 0; // Direction is taken into effect
				optional = 1; // Synced entity is optional
				duplicate = 0; // Multiple entities of this type can be synced
				synced[] = {"AnyBrain"}; // Pre-define entities like "AnyBrain" can be used. See the list below
			};
		};
	};
};




//////// config the custom ending screen for the PVP mode - "jac_bluforVictory" call BIS_fnc_endMissionServer;	

class CfgDebriefing
{  
	class jac_bluforVictory
	{
		title = "BLUFOR VICTORY!";
		subtitle = "";
		description = "";
		pictureBackground = "";
		picture = "b_inf";
		pictureColor[] = { 0.0, 0.3, 0.6, 1 };
	};
	
	class jac_opforVictory
	{
		title = "REDFOR VICTORY!";
		subtitle = "";
		description = "";
		pictureBackground = "";
		picture = "o_inf";
		pictureColor[] = { 0.9, 0.0, 0.0, 0.9 };
	};
	
	class jac_indforVictor
	{
		title = "GREENFOR VICTORY!";
		subtitle = "";
		description = "";
		pictureBackground = "";
		picture = "n_inf";
		pictureColor[] = { 0.0, 0.9, 0.0, 0.9 };
	};
	
	class jac_drawGame
	{
		title = "DRAW GAME";
		subtitle = "";
		description = "";
		pictureBackground = "";
		picture = "b_hq";
		pictureColor[] = { 0.9, 0.9, 0.9, 0.9 };
	};
};












