/////////// WARGAME MANUAL

[] spawn {
waituntil {player == player };

player createDiarySubject ["WARGAME MANUAL", "WARGAME MANUAL"];

player createDiaryRecord ["WARGAME MANUAL", ["TIPS FOR ZEUS","
<br/>
-holding 'SHIFT' while adding units or objects in Zeus will place them on top of the surface under the mouse, such as rooftops and ships
<br/><br/>
-If you are running a mission as a regular Zeus for other players, you might want to go in the Addon options and change some of these options:
<br/><br/>
<font color=""#FFA500"" size=""16"">*</font>Zeus interface 
<br/>
-You can press ’SHIFT+H’ to toggle the unit creation menu and the Minimalist Zeus interface on and off.
<br/><br/>
<font color=""#FFA500"" size=""16"">*</font>Wargame Zeus anywhere
<br/>
-uncheck this option to prevent other players from becoming Zeus.
<br/><br/>
<font color=""#FFA500"" size=""16"">*</font>Activate enemy group 3D icons
<br/>
-uncheck this option to hide the INTERACTIVE ENEMY GROUP ICONs and context menu from the zeus interface.
<br/><br/>
<font color=""#FFA500"" size=""16"">*</font>Show infocard on hover
<br/>
-Uncheck this option to stop the group information card from being displayed when you hover the mouse on a selected group.
<br/><br/>
<font color=""#FFA500"" size=""16"">*</font>Enable the cheat mode for placing fortifications and explosives
<br/>
-Enable this option to be able to place field fortifications and explosives much faster and without resource limits.
<br/><br/>
<font color=""#FFA500"" size=""16"">*</font>Hide units in Fog Of War
<br/>
-Uncheck this option to disable hiding enemy units that have not been spotted by a friendly.
<br/><br/>
<font color=""#FFA500"" size=""16"">*</font>AI default movement mode
<br/>
-By default Zeus controlled AI units will start in 'Hold Position' mode, uncheck this to make units always start in 'Move At Will' mode.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["TROUBLESHOOTING","
<br/>
-Using the CANCEL action and waiting a second will fix most circumstances when a soldier or a vehicle doesn't respond to commands, use the Planning Mode to force the unit to move when stuck in difficult terrain.
<br/><br/>
-To prevent glitches, always keep each vehicle and turret in its own individual group and separate the vehicle crew (driver, gunner, commander) from passengers.
<br/><br/>
-If a vehicle doesn't respond to commands at all, eject all passengers with 'G', then use the GET IN action to get them back inside.
<br/><br/>
-When exiting the Minimalist Interface or Planning Mode, the 'CREATE' menu may appear scrambled and unreadable, simply click on any of the icons at the top of the menu to fix this issue.
"]];

player createDiaryRecord ["WARGAME MANUAL", ["AIR SUPPORT","
<br/>
-If Air Support is available in the scenario the Air Control Panel will show up when the 'TAB' key is pressed.
<br/><br/>
-4 aicraft options are shown at a time, use the mouse wheel to scroll up or down and see all the available aircraft if necessary.
<br/><br/>
-Highlight an option to see information about the cost in Zeus points, the number of times it can be used and the time at which the aircraft will be available (press 'O' to see the mission clock).
<br/><br/>
-Right Click on an aircraft picture to see the AMMO LIST, choose the ordnance that will be delivered by the aircraft.
<br/><br/>
-Left Click
"]];

player createDiaryRecord ["WARGAME MANUAL", ["LOGISTICS AND SUPPLY","
<br/>
-Mission creators can set a vehicle, object or unit to be a SUPPLY POINT; fuel, ammo and Repair trucks will receive this trait automatically.
<br/><br/>
-Selecting a unit and hovering over a Supply Point will show a menu with the options to CHECK SUPPLY, which shows the amount of supply points remaining and SUPPLY.
<br/><br/>
-Clicking on SUPPLY will restore the health, fuel and the loadouts of the units and vehicles currently selected to what they had at the beginning of the mission at the cost of Supply Points.
<br/><br/>
-If you click on a supply point while having a supply vehicle selected, some points from that supply point will be transferred to the selected supply vehicle, this can be used to move supply around.
"]];

player createDiaryRecord ["WARGAME MANUAL", ["FOG OF WAR","	
<br/>
-When the Fog of War system is active, units will use a custom line of sight algorithm to determine if they can spot enemy units.
<br/><br/>
-During an online multiplayer session or when connected to a local LAN server - simply run the game again with the SERVER parameter activated in the launcher then connect to it in the multiplayer servers LAN list - all enemy units will be invisible to the player unless they have been spotted by a friendly unit, 
which opens up a new gameplay dimension to the Wargame mod.
<br/><br/>
<font color=""#FFA500"" size=""14"">-View Range-</font>
<br/>
Each unit has a base view range that indicates the maximum range at which it will spot a vehicle sized target that is fully illuminated (by sunlight or another light source) and fully exposed.
<br/><br/>
The view range is modified by the target's stealth, which is based on several factors:
<br/><br/>
<font color=""#FFA500"" size=""14"">-Environmental light-</font>
<br/>The darker the area the target is in, the harder it will be to spot it, targets in complete darkness can only be spotted at very close range.
<br/><br/>
<font color=""#FFA500"" size=""14"">-Size-</font>
<br/>human sized targets are naturally less visible than vehicles and lowering the stance to kneeling or prone will significantly increase their stealth value.
<br/><br/>
<font color=""#FFA500"" size=""14"">-Movement speed-</font>
<br/>Stationary targets are significantly harder to spot, targets moving faster than slow prone speed will receive a large reduction to their stealth value.
<br/><br/>
<font color=""#FFA500"" size=""14"">-Cover-</font>
<br/>Being partially obscured by cover will make a target much harder to spot, halving the spotting distance when an infantry target is in cover or a vehicle is in a hull down position.
<br/><br/>
<font color=""#FFA500"" size=""14"">-weapon signature-</font>
<br/>Both the noise and flash produced by weapons will give away a target's position, essentially negating any stealth bonus from low light levels, weapon suppressors will significantly reduce this effect.
<br/><br/>
<font color=""#FFA500"" size=""14"">-Communication-</font>
<br/>When an unit spots a target it will pass the information to friendly groups within COMMUNICATION range, this will set the target's stealth value to zero for the units in these groups.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["COMMUNICATION","
<br/>
-Standard groups with a radio will have a comms range of 500 meters, the group will share enemy target information ONLY with HQ groups within this range.
<br/><br/>
-HQ groups have an extended radio range - 1500 meters - and they will distribute target information to ALL groups inside that range.
<br/><br/>
-HQ units can also link a Forward Observer and an indirect fire unit for the purposes of calling Fire Support, extending the range which they can be from each other.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["MAP","
<br/>
-Most waypoints and orders can be used on the map screen as well, such as the AMBUSH and OCCUPY BUILDING commands and the PATH PLANNING MODE.
<br/><br/>
-Press 'F' to move the camera to the mouse position instantly, select an unit or object and press 'F' to focus the camera on its position.
<br/><br/>
-When looking at the map, select a friendly unit to see a circle representing its radio communication range, units will share target information with HQ units and Foward Observers can only request fire support within this range.
<br/><br/>
-A HQ unit can be used to extend the range which a Forward observer is able to call mortar support by linking 2 groups that are outside each others communication range.
<br/><br/>
"]];


player createDiaryRecord ["WARGAME MANUAL", ["GROUP TRAITS AND STATUS","
<br/>
-The group status and traits are displayed when the player hovers the mouse on a selected group, selects a group and presses the 'O' key or when the player clicks the INFO option on an enemy group's target icon.
<br/><br/>
-These traits are a representation of the groups special abilities and unique items, these items and abilities allow the player to use the related TACTICAL MENU commands.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["INTERACTIVE ENEMY GROUP ICON","
<br/>
-Each enemy group that was spotted by one of your units will be marked on the world by an icon based on NATO standard military unit symbols.
<br/><br/>
-Enemy groups that have spotted the Zeus's currently selected group will have a '!' symbol above their group icon.
<br/><br/>
-Hovering over the enemy group icon will show a context menu with several options:
<br/><br/>
<font color=""#FFA500"" size=""16"">-INFO-</font>
<br/>
This is the only option that shows when you don't have any groups selected, displays the target group traits and its suppression status.
<br/><br/>
<font color=""#FFA500"" size=""16"">-TARGET-</font>
<br/>
Tell selected group to target this group, use to snipe enemy units that the AI can't see by itself or to target specific vehicles with AT.
<br/><br/>
<font color=""#FFA500"" size=""16"">-SUPPRESS-</font>
<br/>
Tell selected units to suppress this target position, be careful to avoid moving other units into their field of fire, the AI isn't always able to prevent friendly fire.
<br/><br/>
<font color=""#FFA500"" size=""16"">-GRENADE-</font>
<br/>
Tell selected units to move towards this target's position and throw a grenade on it, this creates a move waypoint near the target and a throw grenade waypoint on top of it,
a good method is to place a move waypoint on the flank of the target position then clicking on this.
<br/><br/>
<font color=""#FFA500"" size=""16"">-CAPTURE-</font>
<br/>
The selected group will move close to the enemy and capture it if it's in a PANICKED state.
<br/><br/>
<font color=""#FFA500"" size=""16"">-KAMIKAZE STRIKE-</font>
<br/>
Appears when an UAV is currently selected, it will order the UAV to chase and ram into the targeted unit or vehicle.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["DYNAMIC CONVOY SYSTEM","
<br/>
-Use the 'FORM UP' option in a vehicle's context sensitive menu to tell a selected vehicle to follow it, you can select multiple vehicles at the same time to form a convoy.
<br/><br/>
-Convoys can be split up by giving a new move order to any vehicle within it.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["CONTEXT SENSITIVE COVER","
<br/>
-Infantry units can be sent to take cover on objects and terrain features in the environment such as walls, rocks and small ditches; simply select the group and right click when the mouse is near suitable cover, the available cover positions will be displayed.
<br/><br/>
-Move the mouse pointer near the cover object to change the spacing between each cover position, set the base spacing value by pressing the left 'ALT' key.
<br/><br/>
-Units in cover will have much better accuracy from bracing their weapon to take more accurate shots, but can be affected by enemy suppressive fire which forces them to go to the prone stance when shot at.
<br/><br/>
-If the Fog Of War spotting system is active, being partially obscured by cover will make a target much harder to spot, halving the spotting distance when an infantry target is in cover or a vehicle is in a hull down position.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["REVERSE MOVE","
<br/>
-Select a vehicle and right click when the mouse is positioned within 100 meters behind the vehicle and it will move in reverse to that position.
"]];


player createDiaryRecord ["WARGAME MANUAL", ["MORALE SYSTEM","
<br/>
-When being attacked while behind cover, units will duck down to hide from enemy fire simulating the effects of SUPPRESSION.
<br/><br/>
-After an unit is pinned down by suppressive fire, sustained fire over a long period of time will lead it to become panicked, going into a cowering animation and preventing it from engaging or moving.
<br/><br/>
-This state lasts for as long as the unit is pinned down or for a number of seconds based on its internal morale stat.
<br/><br/>
-Units in this state can be taken as POWs by using the CAPTURED option from the enemy group's icon menu.
<br/><br/>
-If the number of units attempting to capture the enemy is lower than the enemy's group size, the enemy will immediately break out of the PANICKED state and attack nearby targets!
"]];


player createDiaryRecord ["WARGAME MANUAL", ["PATH PLANNING MODE","
<br/>
-This is a tool for navigating complex terrain and for CQB.
<br/><br/>
-Press ’TAB’ to enter Path Planning mode, every unit will have a colored arrow spawn in front of it, drag this object with the mouse to draw a path that the unit will follow when ’TAB’ is pressed again to exit Planning mode.
<br/><br/>
-Hold the Left CTRL key to delete parts of the path, you can also highlight a path point and delete it with the DELETE key.
<br/><br/>
-Delete the arrow object by pressing the DELETE key in order to clear the entire path and reset to the starting position.
<br/><br/>
-With an infantry unit selected Hold the ALT key while drawing a path to tell the soldier to move laterally or backwards while maintaininig his weapon pointed forward.
<br/>
Hold the SHIFT and use the mouse to turn the Path arrow around to determine the direction the soldier will look at.
<br/><br/>
-With a vehicle selected hold the SHIFT key to activate the Road Magnetization, which will force the drawn path to follow along the road nearest to the mouse pointer.
<br/><br/>
-Draw a closed loop in order to make the unit repeat the path like a patrol, you can stop the movement with the CANCEL action.
<br/><br/>
-Infantry units in COMBAT MODE will stop to engage targets then continue their path, units in MANEUVER MODE will ignore enemies, vehicles will engage on the move.
<br/><br/>
-you can set paths for multiple units at the same time, and you can draw paths on the map screen.
<br/><br/>
-When multiple units are selected by the Zeus while in Planning Mode, dragging a path arrow will synchronize those units paths with the arrow being dragged, when the planned path is executed the units will move together in a file.
<br/><br/>
"]];


player createDiaryRecord ["WARGAME MANUAL", ["QUICK ACTION BAR","
<br/>
-This menu appears on the bottom right of the screen when a group or unit is selected, click on an option to execute the corresponding action.
<br/><br/>

<font color=""#FFA500"" size=""16"">-SET UP-</font>
<br/>
Tell a group that has a heavy static weapon or turret to set up at their current location.
<br/><br/>

<font color=""#FFA500"" size=""16"">-STANCE DOWN-</font>
<br/>
Lower the group stance/flight altitude/dive depth, when an aircraft is on the ground it will turn off the engine.
<br/><br/>

<font color=""#FFA500"" size=""16"">-STANCE UP-</font>
<br/>
Raise the group stance/flight altitude/dive depth.
<br/><br/>

<font color=""#FFA500"" size=""16"">-TOGGLE ACTION MODE-</font>
<br/>
Toggle between Combat mode, units engage targets that they can see as normal and Maneuver mode, units will hold fire, use this to force units to move when under fire.
<br/><br/>
"]];


player createDiaryRecord ["WARGAME MANUAL", ["TACTICAL MENU","

<br/>
-Press 'T' to see the tactical menu where the available commands will be displayed, highlight an option then release the 'T' key to give the order to the currently selected groups:
<br/><br/>

<font color=""#FFA500"" size=""16"">-CANCEL-</font>
<br/>
Stop the group and cancel all current Waypoints and suppress action.
<br/><br/>

<font color=""#FFA500"" size=""16"">-SUPPRESS-</font>
<br/>
Set an arc of fire for the currently selected units by holding the left mouse button or the control key, units will suppress the target position until ordered to stop.
<br/><br/>

<font color=""#FFA500"" size=""16"">-LOOK AT-</font>
<br/>
Turn towards the target position.
<br/><br/>

<font color=""#FFA500"" size=""16"">-GRENADES-</font>
<br/>
Moves towards the target position and throw the selected grenade on it when within range.
<br/><br/>

<font color=""#FFA500"" size=""16"">-SMOKECREEN-</font>
<br/>
Will throw the selected smoke grenade at the target position creating a smokescreen, vehicles will deploy smoke grenade launchers if available.
<br/><br/>

<font color=""#FFA500"" size=""16"">-BUILDING-</font>
<br/>
Select a submenu action to enter the targeted building and occupy fighting positions inside rooms and at windows and balconies, give a movement order or use CANCEL to move the units out.
<br/><br/>

<font color=""#FFA500"" size=""16"">-EXPLOSIVES-</font>
<br/>
Select a submenu action, you can disarm explosives and mines in the area near the target or plant an explosive device; remote controlled explosives will have a handler with an interactive menu option to detonate it.
<br/><br/>

<font color=""#FFA500"" size=""16"">-ENGINEER-</font>
<br/>
Select a submenu action to create field fortifications, dig a hole in the ground or creating a repair station to repair damage vehicles.
<br/>
Select 'BREACH OBSTACLE' to remove an obstacle such as barbed wire or tank traps or fortifications placed by another engineer.
<br/><br/>

<font color=""#FFA500"" size=""16"">-FIRE SUPPORT-</font>
<br/>
Select Indirect Fire to open a menu with all friendly artillery units in range.
<br/>
Laser Designator will create a laser target that can be targeted by laser guided munitions.
<br/>
Kamikaze Strike can be used with an UAV selected to order it to dive and ram into the targeted position.
<br/><br/>

<font color=""#FFA500"" size=""16"">-FORMATION-</font>
<br/>
Select a submenu option to change the selected group formation.
<br/><br/>

<font color=""#FFA500"" size=""16"">-AI OPTIONS-</font>
<br/>
-change speed: Change the movement speed of the selected group, between FAST and SLOW.
<br/><br/>
-hold position: Set AI movement mode to hold position, units will engage enemies in range, but won't pursue or move on their own.
<br/><br/>
-move at will: Set AI movement mode to move at will, this is the vanilla AI behaviour, units will move around on their own to engage enemy targets.
<br/><br/>
-inventory: Open the inventory of the currently selected unit, you can grab and drop itens from containers or the ground.
<br/><br/>
-switch weapon: switch between the primary and secondary weapon.
<br/><br/>
-toggle flashlight: toggle the weapon or vehicle flashlights of the selected groups.
<br/><br/>
-toggle engine: toggle the currently selected ground vehicle engine on and off, when turned on this way, the engine won't be turned off unless ordered to.
<br/><br/>
-direct control: take direct control of the selected unit.
<br/><br/>
-add nearby objects: This option will add friendly units and empty vehicles to the list of zeus controlled objects; must have a friendly unit close to the position to add objects.
<br/><br/>

<font color=""#FFA500"" size=""16"">-AMBUSH-</font>
<br/>
After choosing the ambush option from the Tactical Menu, using the left mouse button click and drag to draw the ambush area, all the currently selected units will watch the area and hold fire until an enemy unit steps inside it.
<br/>
For the ambush to work, a friendly unit must observing the enemy entering the killzone.
<br/>
The ambush position can be set both from the map screen and the 3D view.
<br/><br/>

<font color=""#FFA500"" size=""16"">-VEHICLE WAYPOINT-</font>
<br/>
-unload passengers: The selected vehicle moves to the waypoint and unload any passengers inside it.
<br/><br/>
-land aircraft: Will land the selected plane or helicopter at the waypoint position.
<br/><br/>
-hook to helicopter: Place this close to another vehicle while a helicopter is selected, if it's possible the vehicle will be hooked to the helicopter and can be transported.
<br/><br/>
-unhook from helicopter: The helicopter will move to the waypoint, lower altitude and then unhook a vehicle being transported.
<br/><br/>
-load vehicle inside cargo: Place the waypoint on a vehicke or aircraft able to hold cargo and the selected vehicle will be loaded inside it.
<br/><br/>
-unload vehicles inside cargo: A vehicle or aircraft holding another vehicle inside its cargo will move to the waypoint and unload it.
<br/><br/>
"]];


player createDiaryRecord ["WARGAME MANUAL", ["BASIC CONTROLS","
<br/>
-Press ’SHIFT+H’ to toggle the Minimalist Zeus interface on and off.
<br/><br/>
-Press 'E' to toggle the menu that shows the list of groups under your control.
<br/><br/>
-Press ’TAB’ to enter Path Planning mode.
<br/><br/>
-Use 'CTRL' + a number to save quick selection groups.
<br/><br/>
-Use 'CTRL' + a function key 'F1...F9' to save the camera position, the player will be able quickly return to it by pressing the associated function key.
<br/><br/>
-Select an unit or object and press 'F' to move the camera to its position instantly, if no units are selected the camera will jump to current mouse position.
<br/><br/>
-Use '+' and '-' to increase or reduce the game speed, only functions in single player.
<br/><br/>
-Use 'SHIFT + PGUP' or 'SHIFT + PGDOWN' to change the movement speed of the selected group.
<br/><br/>
-Use 'PGUP' or 'PGDOWN' to change the stance of the selected group.
<br/><br/>
-Use 'PGUP' or 'PGDOWN' to toggle a selected ground vehicle engine on and off.
<br/><br/>
-Use 'G' to order your units to disembark from the selected vehicle.
<br/><br/>
-Use 'C' to cancel all the waypoints of the selected group and cancel a suppression action.
<br/><br/>
-Use 'H' to toggle between Combat and Maneuver modes.
<br/><br/>
-Double tapping 'J' will show the briefing screen.
<br/><br/>
-Press 'L' to drop a signal flare at the mouse position, the flare can be seen by other players in multiplayer.
<br/><br/>
-Press 'O' to display the information card of the currently selected group, which shows its traits, equipment and status.
<br/><br/>
-Press 'I' to open the selected unit's inventory - if there's a vehicle or container in front of it, access its contents.
<br/><br/>
-Press the bracket key '[' to order the selected infantry unit to swap weapons, cycling between the primary weapon and pistol.
<br/><br/>
-Select an unit and press 'CTRL+B' to take direct control of it.
<br/><br/>
-holding 'SHIFT' while adding units or objects in Zeus will place them on top of the surgace under the mouse, such as rooftops and ships
<br/><br/>
-Zeus players can place a 3D marker visible to other Zeus players during multiplayer by using 'Left SHIFT + Left Mouse Button'
"]];
};//spawn
















