///////////// BRIDGE DEPLOY

jac_gm_core_vehicles_fnc_bridge_deploy=
{
private ["_bridgelayingHeightOffset","_posCenter","_posCenterheight","_bridge","_forwardHeightDifference","_ObjectIntersect_02","_ObjectIntersect_01","_layingOffset","_yawDif","_bridgedummyPitchYaw","_vehiclePitchYaw","_terrainIntersect_02","_terrainIntersect_01","_offsetForward_02","_posForward_01","_offsetBack_02","_posBack_02","_offsetBack_01","_posBack_01","_posCheck","_BridgePosition","_up","_dir","_posCenter","_bridgedummy","_dummyForward_02","_dummyForward_01","_dummyBack_02","_dummyBack_01","_dummyCheck","_bridgeDummyClass","_bridgeWidth","_bridgeLength","_bridgelayingOffset","_bridgeType","_bridgelayingTolerance","_bridgelayingYawTolerance","_bridgelayingPitchTolerance","_bridgeHiddenSelections","_bridgelayingAnimFunction"];

_vehicle = _this select 0;


if (local _vehicle) then
{
    _vehicle setVariable ["GM_BRIDGE_STATUS",true,true];

    // Launcher Parameters
    _bridgelayingOffset = getNumber(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingOffset");
    _bridgelayingHeightOffset = getNumber(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingHeightOffset");
    _bridgeType = gettext(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "BridgeType");
    _bridgelayingTolerance = getNumber(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingTolerance");
    _bridgelayingYawTolerance = getNumber(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingYawTolerance");
    _bridgelayingPitchTolerance = getNumber(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingPitchTolerance");
    _bridgeHiddenSelections = getArray(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgehiddenSelections");
    _bridgelayingAnimFunction = getText(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingAnimFunction");

    // Bridge Paramaters
    _bridgeLength = getNumber(configfile  >> "CfgVehicles" >> _bridgeType >> "gm_Bridge"  >> "bridgelength");
    _bridgeWidth = getNumber(configfile  >> "CfgVehicles" >> _bridgeType >> "gm_Bridge"  >> "bridgeWidth");
    _bridgeDummyClass = getText(configfile  >> "CfgVehicles" >> _bridgeType >> "gm_Bridge"  >> "bridgeDummy");
    
    // Spawning measuring objects, as its not possible to fetch memorypoint position above ground
    _dummyCheck = "gm_bridgelaying_helper" createVehicleLocal [1,1,1];
    _dummyBack_01 = "gm_bridgelaying_helper" createVehicleLocal [1,1,1];
    _dummyBack_02 = "gm_bridgelaying_helper" createVehicleLocal [1,1,1];
    _dummyForward_01 = "gm_bridgelaying_helper" createVehicleLocal [1,1,1];
    _dummyForward_02 = "gm_bridgelaying_helper" createVehicleLocal [1,1,1];
    _bridgedummy = _bridgeDummyClass createVehicleLocal [1,1,1];
    _bridgedummy setObjectTexture [0, "#(rgb,8,8,3)color(1,0,0,0.2)"];

    _posCenter = [];
    _dir = [];
    _up = [];
    _BridgePosition = [];

    while {alive _vehicle && !(_vehicle getVariable ["GM_BRIDGE_ACCEPTED",false]) && _vehicle getVariable "GM_BRIDGE_STATUS"} do
    {
        sleep 0.1;
        
        // Layer arm position to compare to possible bridge position, if offset between these position exceed a certain limit bridge building will not be possible
        _posCheck = _vehicle modelToWorldVisualWorld [0,_bridgelayingOffset,0- ((boundingCenter vehicle player) select 2)];
        _dummyCheck setPosASL _posCheck;

        // Left POsition of launcher side of bridge
        _posBack_01 = (_vehicle modelToWorldVisual [(_bridgeWidth/2),_bridgelayingOffset,0]);
        _posBack_01 = [_posBack_01 select 0,_posBack_01 select 1,_bridgelayingTolerance];
        _offsetBack_01 = _posBack_01 select 2;
        _posBack_01 set [2, worldSize]; 
        _dummyBack_01 setPosASL _posBack_01;
        _posBack_01 set [2, vectorMagnitude (_posBack_01 vectorDiff getPosVisual _dummyBack_01) + _offsetBack_01];
        _dummyBack_01 setPosASL _posBack_01;

        // Right POsition of launcher side of bridge
        _posBack_02 = (_vehicle modelToWorldVisual [(0 - (_bridgeWidth/2)),_bridgelayingOffset,0]);
        _posBack_02 = [_posBack_02 select 0,_posBack_02 select 1,_bridgelayingTolerance];
        _offsetBack_02 = _posBack_02 select 2;
        _posBack_02 set [2, worldSize]; 
        _dummyBack_02 setPosASL _posBack_02;
        _posBack_02 set [2, vectorMagnitude (_posBack_02 vectorDiff getPosVisual _dummyBack_02) + _offsetBack_02];
        _dummyBack_02 setPosASL _posBack_02;

        // Far end of the bridge
        _posForward_01 = (_vehicle modelToWorldVisual [0,_bridgeLength + _bridgelayingOffset,0]);
        _posForward_01 = [_posForward_01 select 0,_posForward_01 select 1,_bridgelayingTolerance];
        _offsetForward_01 = _posForward_01 select 2;
        _posForward_01 set [2, worldSize]; 
        _dummyForward_01 setPosASL _posForward_01;
        _posForward_01 set [2, vectorMagnitude (_posForward_01 vectorDiff getPosVisual _dummyForward_01) + _offsetForward_01];
        _dummyForward_01 setPosASL _posForward_01;

        // Far end of the bridge with 1 meter offset to define restign area of bridge
        _posForward_02 = (_vehicle modelToWorldVisual [0,_bridgeLength + _bridgelayingOffset -1,0]);
        _posForward_02 = [_posForward_02 select 0,_posForward_02 select 1,_bridgelayingTolerance];
        _offsetForward_02 = _posForward_02 select 2;
        _posForward_02 set [2, worldSize]; 
        _dummyForward_02 setPosASL _posForward_02;
        _posForward_02 set [2, vectorMagnitude (_posForward_02 vectorDiff getPosVisual _dummyForward_02) + _offsetForward_02];
        _dummyForward_02 setPosASL _posForward_02;

        // Checking which point to use for bridge direction check, Forward_01 or Forward 02
        // If The front is lower then the back 01 should be used
        // If the front is higher then the back 02 should be used
        _forwardHeightDifference = (_posForward_01 select 2) - (_posCheck select 2);

        // Various deployment conditions
        _terrainIntersect_01 = !(terrainIntersectASL [_posBack_01, _posForward_01]); // Getting intersections with terrain
        _terrainIntersect_02 = !(terrainIntersectASL [_posBack_02, _posForward_01]); // Getting intersections with terrain
        _vehiclePitchYaw = _vehicle call BIS_fnc_getPitchBank; // Getting pitch and Yaw angle of vehicle
        _bridgedummyPitchYaw = _bridgedummy call BIS_fnc_getPitchBank; // Getting pitch and Yaw angle of bridge
        _pitchDif = (_vehiclePitchYaw select 0) - (_bridgedummyPitchYaw select 0); // Getting pitch angle difference between launcher and bridge
        _yawDif = (_vehiclePitchYaw select 1) - (_bridgedummyPitchYaw select 1); // Getting yaw angle difference between launcher and bridge
        _layingOffset = (_posBack_02 select 2) - (_posCheck select 2); // Getting height offset between suggested bridge position and launcher
        _ObjectIntersect_01 = !(lineIntersects [_posBack_01,_posForward_01,_vehicle,_bridgedummy]); // Checking if bridge is intersecting with an Object
        _ObjectIntersect_02 = !(lineIntersects [_posBack_01,_posForward_02,_vehicle,_bridgedummy]); // Checking if bridge is intersecting with an Object

        // The final resting vector and position depends on which forward position is used, based on the height difference between the far end of bridge and the layer.
        if (_forwardHeightDifference > 0) then
        {
            // Center of the positions defining where the bridge is located
            _posCenter = (_vehicle modelToWorldVisual [0,(_bridgeLength/2) + _bridgelayingOffset,0]);
            _posCenterheight = (((_posForward_02 select 2) - (_posBack_01 select 2))/2) + (_posBack_01 select 2);
            _posCenter set [2, _posCenterheight]; 
            _bridgedummy setPosASL _posCenter;
            _dir = _posCenter vectorFromTo _posForward_02;
            _up = (_posBack_02 vectorFromTo _posForward_02) vectorCrossProduct (_posBack_01 vectorFromTo _posForward_02);
        }
        else
        {
            // Center of the positions defining where the bridge is located
            _posCenter = (_vehicle modelToWorldVisual [0,(_bridgeLength/2) + _bridgelayingOffset,0]);
            _posCenterheight = (((_posForward_01 select 2) - (_posBack_01 select 2))/2) + (_posBack_01 select 2);
            _posCenter set [2, _posCenterheight]; 
            _bridgedummy setPosASL _posCenter;
            _dir = _posCenter vectorFromTo _posForward_01;
            _up = (_posBack_02 vectorFromTo _posForward_01) vectorCrossProduct (_posBack_01 vectorFromTo _posForward_01);
            
        };
        
        _bridgedummy setVectorDir _dir;
        _bridgedummy setVectorUp _Up;
        _BridgePosition = [_posCenter,_dir,_up];
		
		_bridgedummy setObjectTexture [0, "#(rgb,8,8,3)color(0,1,0,0.05)"];
		
        // Add condition to accept user action that the speed must be lower then 1 m/s
        // Green or Red depending of position is valid or if not
		/*
        if (_terrainIntersect_01 && _terrainIntersect_02 && ((_ObjectIntersect_01 && _forwardHeightDifference <= 0) or ( _ObjectIntersect_02 && _forwardHeightDifference > 0)) && (abs(_pitchDif) < _bridgelayingPitchTolerance) && (abs(_yawDif) < _bridgelayingYawTolerance) && (abs(_layingOffset)) < _bridgelayingHeightOffset) then
        {
            _bridgedummy setObjectTexture [0, "#(rgb,8,8,3)color(0,1,0,0.05)"];
            _vehicle setVariable ["GM_BRIDGE_INPOSITION",true,true];
        }
        else
        {
            _bridgedummy setObjectTexture [0, "#(rgb,8,8,3)color(1,0,0,0.05)"];
            _vehicle setVariable ["GM_BRIDGE_INPOSITION",false,true];
        };
		*/
    };

    deletevehicle _bridgedummy; 
    deletevehicle _dummyCheck; 
    deletevehicle _dummyBack_01;
    deletevehicle _dummyBack_02; 
    deletevehicle _dummyForward_01; 
    deletevehicle _dummyForward_02; 

    _vehicleDir = getDir _vehicle;
    _hasAnim = 1;
    if (_hasAnim == 1 && _vehicle getVariable "GM_BRIDGE_STATUS" && alive _vehicle) then
    {
        _anim = [_vehicle,_vehicleDir] spawn compile preprocessFileLineNumbers _bridgelayingAnimFunction;
        waitUntil {scriptDone _anim}; // Wait for the script to be done
    };

    if (_vehicle getVariable "GM_BRIDGE_STATUS"  && alive _vehicle) then
    {
        // move bridgeclass to config of Vehicle launching it.
        _bridge = _bridgeType createVehicle [10,10,10];
        _bridge setVectorDir (_BridgePosition select 1);
        _bridge setVectorUp (_BridgePosition select 2);
        [_vehicle,_bridgeHiddenSelections,_bridge,_bridgeHiddenSelections] call gm_core_fnc_matchObjectTexture;
        // [_vehicle,_bridgeHiddenSelections,_bridge,_bridgeHiddenSelections] call gm_core_fnc_matchObjectTexture;
        _bridge setPosASL (_BridgePosition select 0);
        _vehicle setVariable ["GM_BRIDGE_BRIDGELOADED",false,true];
        _bridge allowdamage false;
    };
    _vehicle setVariable ["GM_BRIDGE_ACCEPTED",false,true];
    _vehicle setVariable ["GM_BRIDGE_STATUS",false,true];
    _vehicle setVariable ["GM_BRIDGE_INPOSITION",false,true];
};
};


///////////// BRIDGE PICK UP

jac_gm_core_vehicles_fnc_bridge_pickup=
{
private ["_posFront","_posBack","_bridge","_bridgepickupOffset","_bridgelayerFootprint","_bridgeType","_bridgelayingTolerance","_bridgelayingAngularTolerance","_bridgeHiddenSelections","_bridgePickupAnimFunction","_bridgeLength","_bridgeWidth"];

_vehicle = _this select 0;

if (local _vehicle) then
{
	// Launcher Parameters

	_bridgelayerFootprint = gettext(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayerFootprint");
	_bridgeType = gettext(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "BridgeType");
	_bridgelayingTolerance = getNumber(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingTolerance");
	_bridgelayingAngularTolerance = getNumber(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgelayingAngularTolerance");
	_bridgeHiddenSelections = getArray(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgehiddenSelections");
	_bridgePickupAnimFunction = getText(configfile  >> "CfgVehicles" >> typeOf _vehicle >> "gm_Bridge"  >> "bridgePickupAnimFunction");

	// Bridge Paramaters
	_bridgeLength = getNumber(configfile  >> "CfgVehicles" >> _bridgeType >> "gm_Bridge"  >> "bridgelength");
	_bridgeWidth = getNumber(configfile  >> "CfgVehicles" >> _bridgeType >> "gm_Bridge"  >> "bridgeWidth");
	_bridgepickupOffset = getNumber(configfile  >> "CfgVehicles" >> _bridgeType >> "gm_Bridge"  >> "bridgePickupOffset");
	
	_bridge = nearestObject [_vehicle, _bridgeType];

	if (!(isnull _bridge)) then
	{
		_posFront = _bridgelayerFootprint createVehicleLocal [1,1,1];
		_posBack = _bridgelayerFootprint createVehicleLocal [1,1,1];

		_BridgePosition = [];
		_vehicle setVariable ["GM_BRIDGE_STATUS",true,true];

		while {alive _bridge && !(_vehicle getVariable ["GM_BRIDGE_ACCEPTED",false]) && _vehicle getVariable "GM_BRIDGE_STATUS" && (_bridge distance _vehicle) < 50 && !(isnull _bridge)} do
		{
			sleep 0.1;
			_pos1 = (_bridge modelToWorldVisual [0,(_bridgeLength/2)+_bridgepickupOffset,0]);
			_pos1 = [_pos1 select 0,_pos1 select 1,_bridgelayingTolerance];
			_pos2 = (_bridge modelToWorldVisual [0,0 - ((_bridgeLength/2)+_bridgepickupOffset) ,0]);
			_pos2 = [_pos2 select 0,_pos2 select 1,_bridgelayingTolerance];
			_posFront setPos _pos1;
			_posFront SetDir ((getDir _bridge) - 180);
			_posBack setPos _pos2;
			_posBack SetDir getDir _bridge;
			
			_angle1 = abs(getDir _vehicle - getDir _posFront);
			_angle2 = abs(getDir _vehicle - getDir _posBack);
			
			_myAngle1= getDir _vehicle; _myAngle2= _vehicle getDir _bridge; _myAngle3= getDir _bridge;
			_myAngleDiff = abs(((_myAngle1) mod 360) - _myAngle2);	_myAngleDiff2 = abs(_myAngle3 - _myAngle1);	// Calculate the absolute difference between the angles
			
			if ((_posFront distance2D _vehicle < (_bridgelayingTolerance * 10) && _angle1 < 16) or (_posBack distance2D _vehicle < (_bridgelayingTolerance * 10) && _angle2 < 16)) then
			{
				_posFront setObjectTexture [0, "#(rgb,8,8,3)color(0,1,0,0.05)"];
				_posBack setObjectTexture [0, "#(rgb,8,8,3)color(0,1,0,0.05)"];   
				_vehicle setVariable ['GM_BRIDGE_INPOSITION', true, true];
			}
			else
			{
				_posFront setObjectTexture [0, "#(rgb,8,8,3)color(1,0,0,0.05)"];
				_posBack setObjectTexture [0, "#(rgb,8,8,3)color(1,0,0,0.05)"];
				_vehicle setVariable ['GM_BRIDGE_INPOSITION', false, true];
			};
			
			// hintsilent format ["%1\n%2\n%3\n%4\n%5",_posFront distance2D _vehicle,_posBack distance2D _vehicle,_angle1,_angle2,_vehicle getVariable "GM_BRIDGE_INPOSITION"];
		   /*
		   if ((_posFront distance2D _vehicle < (_bridgelayingTolerance * 10) && _angle1 < _bridgelayingAngularTolerance) or (_posBack distance2D _vehicle < (_bridgelayingTolerance * 10) && _angle2 < _bridgelayingAngularTolerance)) then
			{
				_posFront setObjectTexture [0, "#(rgb,8,8,3)color(0,1,0,0.05)"];
				_posBack setObjectTexture [0, "#(rgb,8,8,3)color(0,1,0,0.05)"];
				_vehicle setVariable ["GM_BRIDGE_INPOSITION",true,true];
			}
			else
			{
				_posFront setObjectTexture [0, "#(rgb,8,8,3)color(1,0,0,0.05)"];
				_posBack setObjectTexture [0, "#(rgb,8,8,3)color(1,0,0,0.05)"];
				_vehicle setVariable ["GM_BRIDGE_INPOSITION",false,true];
			};
			*/
		};

		deletevehicle _posFront; 
		deletevehicle _posBack;
		
		_vehicleDir = getDir _vehicle;
		
		if (_vehicle getVariable "GM_BRIDGE_STATUS" && alive _vehicle && alive _bridge && (_bridge distance _vehicle) < 50 && !(isnull _bridge)) then
		{
			_hasAnim = 1;
			if (_hasAnim == 1) then
			{
				_anim = [_vehicle,_vehicleDir,_bridge] spawn compile preprocessFileLineNumbers _bridgePickupAnimFunction;
				waitUntil {scriptDone _anim}; // Wait for the script to be done
				// _anim = [_vehicle,_bridgelayingTolerance,_bridge] spawn gm_biber_fnc_bridge_animpickup;
				// waitUntil { scriptDone _anim};
			};
			if (!(isNull _bridge) && _vehicle getVariable "GM_BRIDGE_STATUS" && alive _vehicle && alive _bridge) then
			{
				[_bridge,_bridgeHiddenSelections,_vehicle,_bridgeHiddenSelections] call gm_core_fnc_matchObjectTexture;
				deletevehicle _bridge;
			};
			_vehicle setVariable ["GM_BRIDGE_BRIDGELOADED",true,true];
		};
	};

	_vehicle setVariable ["GM_BRIDGE_ACCEPTED",false,true];
	_vehicle setVariable ["GM_BRIDGE_STATUS",false,true];
	_vehicle setVariable ["GM_BRIDGE_INPOSITION",false,true];
};
};


////////// GM BRIDGELAYER interactive menu
jac_fnc_initBridgeLayer=
{
	params ["_obj"];
	if ( !(_obj getVariable ["jac_hasInitBridgeLayer", false]) ) then
	{
		_obj setVariable ["jac_hasInitBridgeLayer",true];
		_optionData= _obj getVariable ['jac_interactiveMenuArray', []];
		_optionData pushBack ["PREPARE", "jac_fnc_doPrepareBridgeVehicle", "Prepare the vehicle to deploy or pick up bridge", 1];
		_optionData pushBack ["ACTIVATE", "jac_fnc_activateBridgeVehicle", "Activate the deploying or picking up bridge animation.", 1];
		_obj setVariable ['jac_interactiveMenuArray', _optionData];
	};
};

jac_fnc_doPrepareBridgeVehicle=
{
	params ["_ctrlPos", "_ctrlOBJ", "_grpArray"];
	_veh= _ctrlOBJ; if !(local _veh) exitWith {false};
	if ( !(_veh getVariable ['GM_BRIDGE_ACCEPTED', false]) && (_veh getVariable ['GM_BRIDGE_STATUS',false]) ) exitWith {_veh setVariable ['GM_BRIDGE_STATUS',false,true]};	//cancel and reset deploy/pickup mode
	
	if (_veh getVariable ['GM_BRIDGE_BRIDGELOADED',true]) then 		//bridge is on the vehicle
	{
		[_veh] spawn jac_gm_core_vehicles_fnc_bridge_deploy;
		_veh spawn { sleep 0.75; _this setVariable ['GM_BRIDGE_INPOSITION', true, true]}; //this tells the position is valid - for this mod bridges can placed anywhere
	}
	else
	{
		[_veh] spawn jac_gm_core_vehicles_fnc_bridge_pickup;	//will check for a bridge in proper position before allowing pickup
	};
};

jac_fnc_activateBridgeVehicle=
{
	params ["_ctrlPos", "_ctrlOBJ", "_grpArray"];
	_veh= _ctrlOBJ; if ( !(local _veh) or !(alive _veh) or !(alive (driver _veh)) ) exitWith {false};
	
	if ( !(_veh getVariable ['GM_BRIDGE_ACCEPTED', false]) && (_veh getVariable ['GM_BRIDGE_INPOSITION', false]) ) then
	{
		_veh setVariable ['GM_BRIDGE_ACCEPTED',true,true];	//starts the animation
	};
};















