/////////// group will enter building and occupy positions inside
//jac_fnc_wp_occupyBuilding

params ["_group", "_position", "_target", "_garrisonTeleport", "_fromTop", "_clearBuilding"];	//first 3 arg are obligatory
if !(local _group) exitWith {false};

_targetDis= 2.5; if ((_garrisonTeleport) && !(_clearBuilding)) then {_targetDis= 999999};

[_position] call jac_fnc_nearestBuildingPositions params ['_targetBuilding', '_buildingPosArray', '_buildingPosCount'];
if (isNull _targetBuilding) exitWith {false};

//order units by height from higher to lower
_buildingPosArrayOrdered= [];
{
	_pos= _x;
	_listId= _buildingPosArrayOrdered findIf { (_pos # 2) <= (_x # 2) };
	_buildingPosArrayOrdered insert [_listId, [_x]];
} forEach _buildingPosArray;

_buildingSize= ((0 boundingBoxReal _targetBuilding) # 2);

_units= (units _group); _units doFollow (leader _group);
_group setVariable ['jac_doFormUp', false, true];	//cancel stacking behind vehicle

_i= 0; _iMod= 1; _iEnd= (_buildingPosCount);
if ((_fromTop) && !(_clearBuilding)) then {_i= (_buildingPosCount-1); _iMod= -1; _iEnd= -1};

{
	_unit= _x; _unitId= _forEachIndex; _unit setVariable ['jac_doMoveCoverPos', [], true];
	if ( !(_group getVariable ['jac_isDugIn', false]) && (_unit getVariable ['jac_isInCover', false]) ) then {_unit enableAi 'PATH'};	//enable path if in cover, but not dug in
	_moveToMarker= _unit getVariable ['jac_moveToMarker', objNull]; deleteVehicle _moveToMarker;		
	_unit setVariable ['jac_isMovingToCoverPos', false, true];
	_unit setVariable ['jac_pathCalculated', false];
	_unit setVariable ['jac_endMovingToCoverPos', true, true];
	_unit setVariable ['jac_endScriptedMove', true, true]; //end scripted move
	
	if (_buildingPosCount > 0) then 
	{
		_unit setVariable ["jac_isClearingBuilding", false, true];
		if !(_clearBuilding) then
		{
			//get pos to move to
			if (_i != _iEnd) then {_position = (_buildingPosArrayOrdered # _i)} else {_position = selectRandom _buildingPosArrayOrdered; _iMod= 0}; 
			_i= (_i + _iMod);
			_unit setVariable ['jac_doMoveGarrisonPos', _position];
			
			[_unit, _position, _targetDis, _buildingSize, _targetBuilding] spawn jac_fnc_unitGarrison;	//move unit to its garrison position
		}
		else
		{
			if (_unit == leader _unit) then {[200, _unit, "CLEAR THAT BUILDING!"] remoteExec ["jac_fnc_zeusAddMSG3D", 0]}; sleep 1; _unit setVariable ["jac_isClearingBuilding", true, true];
			[_unit, _buildingPosArrayOrdered, _group, _targetDis, _iEnd, _unitId] spawn 
			{
				params ["_unit", "_buildingPosArrayOrdered", "_group", "_targetDis", "_iEnd", "_unitId"];
				
				// clear each building pos in sequence
				for "_i" from 0 to (0 max (((count _buildingPosArrayOrdered) -1) - _unitId)) step +1 do {
					_moveToPos= (_buildingPosArrayOrdered # _i); _unitPos= getPosATL _unit;
					if ([_unitPos, _moveToPos] call jac_fnc_linePath) then
					{
						_path= [(_moveToPos), (_moveToPos)];
						[_unit, _path, jac_scriptedMoveSpacing, jac_scriptedMoveTurnSpd, false] remoteExec ["jac_fnc_scriptedMove", 0];
					}
					else 
					{_unit doMove (_moveToPos)};
					
					_doMoveTime= CBA_missionTime;
					waitUntil {sleep 0.001; ( !(alive _unit) or (_unit distance _moveToPos < _targetDis) or (_group getVariable ["jac_isCancelAction", false]) or !(_unit getVariable ["jac_isClearingBuilding", false]) 
					or ( (CBA_missionTime > (5 + _doMoveTime)) && (_unitPos distance _unit) < 1 ) )}; sleep 0.5;	//if hasn't moved in a while try the next position
					
					if (_unit distance _moveToPos <= _targetDis) then {doStop _unit};
					
					if ( !(alive _unit) or (_group getVariable ["jac_isCancelAction", false]) or !(_unit getVariable ["jac_isClearingBuilding", false]) )
					exitWith {_unit setVariable ["jac_isClearingBuilding", false, true]; terminate _thisScript};
				};
				
				//damage nearest window
				[getPosATL _unit] call jac_fnc_findNearestWindow params ["_selectedWindowPos", "_closestDis", "_building", "_WindowName"];
				if (_closestDis < 4) then {_building setHitPointDamage [_WindowName, 1]};
				
				_unit setVariable ["jac_isClearingBuilding", false, true];
			};//spawn
		};
	}
	else
	{
		_x doMove _position;
	};
} forEach _units;
true;

















